/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.enums.YYLoggerTuJingEnum
 *  fire.pb.talk.MessageMgr
 *  fire.pb.title.STitleConfig
 *  fire.pb.title.Title
 *  fire.pb.title.TitleManager
 *  fire.pb.util.BagUtil
 *  mkdb.Procedure
 *  xbean.PvP5RaceRole
 *  xtable.Properties
 */
package fire.pb.battle.pvp5;

import fire.log.enums.YYLoggerTuJingEnum;
import fire.pb.battle.pvp5.PvP5Helper;
import fire.pb.battle.pvp5.PvP5RaceProxy;
import fire.pb.battle.pvp5.PvP5RankVisitor;
import fire.pb.battle.pvp5.PvP5RoleProxy;
import fire.pb.talk.MessageMgr;
import fire.pb.title.STitleConfig;
import fire.pb.title.Title;
import fire.pb.title.TitleManager;
import fire.pb.util.BagUtil;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;
import mkdb.Procedure;
import xbean.PvP5RaceRole;
import xtable.Properties;

public class PvP5Judge {
    private final PvP5RaceProxy raceProxy;

    public PvP5Judge(PvP5RaceProxy race) {
        this.raceProxy = race;
    }

    public EResult predict() {
        int roleNumB;
        int roleNumA = PvP5Judge.getExcellentRoleNum(this.raceProxy.getXRace().getAllrolesidcampa());
        if (roleNumA != (roleNumB = PvP5Judge.getExcellentRoleNum(this.raceProxy.getXRace().getAllrolesidcampb()))) {
            if (roleNumA == 0) {
                return EResult.BWIN;
            }
            if (roleNumB == 0) {
                return EResult.AWIN;
            }
        }
        return EResult.NULL;
    }

    public void judge() {
        int roleNumB;
        EResult result = EResult.NULL;
        int roleNumA = PvP5Judge.getExcellentRoleNum(this.raceProxy.getXRace().getAllrolesidcampa());
        if (roleNumA > (roleNumB = PvP5Judge.getExcellentRoleNum(this.raceProxy.getXRace().getAllrolesidcampb()))) {
            result = EResult.AWIN;
        } else if (roleNumA < roleNumB) {
            result = EResult.BWIN;
        } else {
            Integer[] titles = PvP5Helper.getTitleAward(this.raceProxy.getGrade());
            if (titles != null) {
                List<PvP5RaceRole> tempRoleList = PvP5RankVisitor.getCurrentRankListAndSort(this.raceProxy, titles.length);
                HashSet<Long> idsA = new HashSet<Long>();
                HashSet<Long> idsB = new HashSet<Long>();
                PvP5Judge.getCampRankListRoleIdSet(this.raceProxy, titles.length, idsA, idsB);
                int numA = 0;
                int numB = 0;
                for (int i = 0; i < titles.length && i < tempRoleList.size(); ++i) {
                    PvP5RaceRole raceRole = tempRoleList.get(i);
                    if (idsA.contains(raceRole.getRoleid())) {
                        ++numA;
                        continue;
                    }
                    if (!idsB.contains(raceRole.getRoleid())) continue;
                    ++numB;
                }
                if (numA != numB) {
                    result = numA > numB ? EResult.AWIN : EResult.BWIN;
                } else if (tempRoleList.size() > 0) {
                    long firstRoleId = tempRoleList.get(0).getRoleid();
                    EResult eResult = result = idsA.contains(firstRoleId) ? EResult.AWIN : EResult.BWIN;
                }
            }
        }
        if (result != EResult.NULL) {
            int camp = result == EResult.AWIN ? 0 : 1;
            LinkedList<String> strings = new LinkedList<String>();
            strings.add(PvP5Helper.getGradeName(this.raceProxy.getGrade()));
            strings.add(String.valueOf(roleNumA));
            strings.add(String.valueOf(roleNumB));
            strings.add(PvP5Helper.getCampName(camp));
            if (roleNumA != roleNumB) {
                MessageMgr.broadcastMsgNotify((int)172037, (int)-1, strings);
            } else {
                MessageMgr.broadcastMsgNotify((int)172036, (int)-1, strings);
            }
            this.award(result);
        }
    }

    public void award(EResult result) {
        int camp = 0;
        List roles = null;
        if (result == EResult.AWIN) {
            camp = 0;
            roles = this.raceProxy.getXRace().getAllrolescampa();
        } else if (result == EResult.BWIN) {
            camp = 1;
            roles = this.raceProxy.getXRace().getAllrolescampb();
        }
        if (roles != null) {
            this.award(roles, camp);
        }
    }

    private void award(List<PvP5RaceRole> roleList, int camp) {
        int i;
        LinkedList<String> strings = new LinkedList<String>();
        strings.add(PvP5Helper.getGradeName(this.raceProxy.getGrade()));
        strings.add(PvP5Helper.getCampName(camp));
        MessageMgr.broadcastMsgNotify((int)172020, (int)-1, strings);
        Integer[] titles = PvP5Helper.getTitleAward(this.raceProxy.getGrade());
        if (titles != null) {
            for (i = 0; i < titles.length && i < roleList.size(); ++i) {
                Integer titleId = titles[i];
                STitleConfig titleConfig = TitleManager.getTitleConfigById((int)titleId);
                if (titleConfig == null) continue;
                PvP5RaceRole raceRole = roleList.get(i);
                long roleId = raceRole.getRoleid();
                int rank = i + 1;
                Procedure proc = this.createAwardProc(roleId, titleId, rank, 340010);
                Procedure.pexecuteWhileCommit((Procedure)proc);
                LinkedList<String> strings2 = new LinkedList<String>();
                strings2.add(Properties.selectRolename((Long)roleId));
                strings2.add(PvP5Helper.getGradeName(this.raceProxy.getGrade()));
                strings2.add(PvP5Helper.getCampName(camp));
                strings2.add(String.valueOf(rank));
                strings2.add(titleConfig.titlename);
                MessageMgr.broadcastMsgNotify((int)172021, (int)-1, strings2);
            }
        }
        for (i = 5; i < 15 && i < roleList.size(); ++i) {
            PvP5RaceRole raceRole = roleList.get(i);
            long roleId = raceRole.getRoleid();
            int rank = i + 1;
            int awardId = -1;
            if (rank >= 6 && rank <= 10) {
                awardId = 340011;
            } else {
                if (rank < 11 || rank > 15) continue;
                awardId = 340012;
            }
            if (awardId <= 0) continue;
            Procedure proc = this.createAwardProc(roleId, -1, rank, awardId);
            Procedure.pexecuteWhileCommit((Procedure)proc);
        }
    }

    private Procedure createAwardProc(final long roleId, final int titleId, int rank, final int awardId) {
        Procedure proc = new Procedure(){

            protected boolean process() {
                int itemNum;
                int itemId;
                int num;
                STitleConfig titleConfig = TitleManager.getTitleConfigById((int)titleId);
                if (titleConfig != null) {
                    Title title = new Title(roleId, false);
                    if (title.roleHaveTitle(titleId)) {
                        title.removeTitle(titleId);
                    }
                    title.addTitle(titleId, titleConfig.getTitlename(), -1L);
                }
                if ((num = BagUtil.addItem((long)roleId, (int)(itemId = awardId), (int)(itemNum = 1), (String)"PVP5排名奖励", (YYLoggerTuJingEnum)YYLoggerTuJingEnum.tujing_Value_PVP5, (int)itemId)) < itemNum) {
                    // empty if block
                }
                return true;
            }
        };
        return proc;
    }

    private static int getExcellentRoleNum(List<Long> roleIds) {
        int num = 0;
        for (Long roleId : roleIds) {
            PvP5RoleProxy roleProxy = PvP5RoleProxy.getPvP5RoleProxy(roleId, true);
            if (roleProxy.getExcellent() != 1) continue;
            ++num;
        }
        return num;
    }

    private static void getCampRankListRoleIdSet(PvP5RaceProxy raceProxy, int recordMax, Set<Long> outIdsA, Set<Long> outIdsB) {
        List roleListA = raceProxy.getXRace().getAllrolescampa();
        List roleListB = raceProxy.getXRace().getAllrolescampb();
        int max = Math.max(roleListA.size(), roleListB.size());
        max = Math.min(recordMax, max);
        for (int i = 0; i < max; ++i) {
            if (i < roleListA.size()) {
                outIdsA.add(((PvP5RaceRole)roleListA.get(i)).getRoleid());
            }
            if (i >= roleListB.size()) continue;
            outIdsB.add(((PvP5RaceRole)roleListB.get(i)).getRoleid());
        }
    }

    public static enum EResult {
        AWIN,
        BWIN,
        NULL;

    }
}

